import { VisibilityRulesService } from '../../visibility-rules/visibility-rules.service';
import { FormGroup, Form, FormArray } from '@angular/forms';
import { Component, Input, OnInit, ViewEncapsulation } from '@angular/core';
import { CompositeField } from '../../models/CompositeField';


@Component({
  selector: 'df-section',
  templateUrl: './dynamic-form-section.html',
  styleUrls: [
    './dynamic-form-section.css'
  ],
  encapsulation: ViewEncapsulation.None,
})
export class DynamicFormSectionComponent implements OnInit {

  @Input() section: Section
  @Input() form: FormGroup;
  @Input() pathName: string;
  @Input() path: string;
  constructor(private visibilityRulesService:VisibilityRulesService) { }

  ngOnInit() {
    console.log(this.section);
  }

  addMultipleField(fieldsetIndex: number) {
    let compositeField: CompositeField = this.section.compositeFields[fieldsetIndex].cloneForMultiplicity(fieldsetIndex);
    this.section.compositeFields[fieldsetIndex].multiplicityItems.push(compositeField);
    (<FormArray>(this.form.get("compositeFields").get('' + fieldsetIndex).get('multiplicityItems'))).push(compositeField.buildForm());
  }

  isVisible(fieldSet:CompositeField):boolean{
    if(!this.visibilityRulesService.isElementVisible(null,fieldSet.id)) return false;
    for(var i=0; i<fieldSet.fields.length; i++){
      if (!this.visibilityRulesService.isElementVisible(null,fieldSet.fields[i].id)) 
      return false;
    }
    return true;
  }
}